#include "StdAfx.h"
#include "AddinModule.h"
 
namespace AdxHT_006_VC
{
    //Add-in Module Implementation

	Outlook::_Application* AddinModule::OutlookHost(void)
	{
		return __try_cast<Outlook::_Application*>(HostApplication);
	}

	void AddinModule::DoClick(System::Object* sender)
	{
		MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarControl*>(sender)->Caption, "Add-in Express .NET (VC)");
	}

	void AddinModule::DoCommandBarsUpdate(void)
	{
		Outlook::NameSpace* NameSpace_ = OutlookHost()->GetNamespace("MAPI");
		Outlook::Explorer* ActiveExplorer = OutlookHost()->ActiveExplorer();
		if ((ActiveExplorer != 0) && (NameSpace_ != 0) )
		{
			Outlook::MAPIFolder* DefaultFolder = NameSpace_->GetDefaultFolder(Outlook::OlDefaultFolders::olFolderCalendar);
			Outlook::MAPIFolder* CurrentFolder = ActiveExplorer->CurrentFolder;
			if ((DefaultFolder != 0) && (CurrentFolder != 0))
			{
				if (System::String::Compare(CurrentFolder->EntryID, DefaultFolder->EntryID) == 0)
				{
					this->CommandBarsObj = ActiveExplorer->CommandBars;
					Office::CommandBar* ContextBar;
					System::String* obj_name = "Context Menu";
					ContextBar = __try_cast<Office::CommandBar*>(this->FindCommandBarObj(obj_name));
                    if (ContextBar != 0) 
					{
						if (ContextBar->Controls->Count > 0) 
						{
							Office::CommandBarControl* StandardNewButton = 0;
							Office::CommandBarControl* NewButton = 0;
							try
							{
								StandardNewButton = __try_cast<Office::CommandBarControl*>(ContextBar->Controls->Item[__box(1)]);
                                if ((StandardNewButton != 0) && 
									((System::String::Compare(StandardNewButton->Caption, "New App&ointment") == 0) || (StandardNewButton->Caption == "&Open"))
									) 
								{
									System::String* my_tag = "MY_UNIQUE_TAG_VC";
									NewButton = ContextBar->FindControl(__box(Office::MsoControlType::msoControlButton), Type::Missing, my_tag, Type::Missing, Type::Missing);
									if (NewButton == 0)
									{
                                        ContextBar->Reset();
										ContextBar->Protection = Office::MsoBarProtection::msoBarNoProtection;
										if (adxCommandBar == 0) 
										{
											adxCommandBar = new AddinExpress::MSO::ADXCommandBar();
                                            adxCommandBar->CommandBarObj = ContextBar;
										}
                                        else
										{
											adxCommandBar->Controls->Clear();
										}
										AddinExpress::MSO::ADXCommandBarButton* adxNewButton = new AddinExpress::MSO::ADXCommandBarButton();
										adxNewButton->ControlTag = my_tag;
										adxNewButton->Before = 0;
                                        adxNewButton->Temporary = true;
                                        adxNewButton->BeginGroup = true;
										adxNewButton->Style = AddinExpress::MSO::ADXMsoButtonStyle::adxMsoButtonCaption;
                                        adxNewButton->Caption = "Test Button (VC)";
										adxNewButton->Click += new AddinExpress::MSO::ADXClick_EventHandler(this, DoClick);

                                        if (adxCommandBar->Controls->Add(adxNewButton) != 0) 
										{
											adxNewButton->ControlObj = ContextBar->Controls->Add(__box(Office::MsoControlType::msoControlButton), Type::Missing, Type::Missing, Type::Missing, Type::Missing);
                                            adxNewButton->UpdateControlObj(this);
										}
										else
										{
											Marshal::ReleaseComObject(NewButton);
										}

										Marshal::ReleaseComObject(StandardNewButton);
									}
								}
							}
							catch(System::Exception*)
							{
							}

						}
						Marshal::ReleaseComObject(ContextBar);
					}
					this->CommandBarsObj = 0;
				}
				Marshal::ReleaseComObject(DefaultFolder);
				Marshal::ReleaseComObject(CurrentFolder);
			}
		    Marshal::ReleaseComObject(ActiveExplorer);
		    Marshal::ReleaseComObject(NameSpace_);
		}
	}

}

