#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Diagnostics;
using namespace Extensibility;
using namespace System::Windows::Forms;
using namespace System::Runtime::InteropServices;
 
namespace AdxHT_006_VC
{
    //Add-in Express Add-in Module
    [GuidAttribute("9CA5BE3F-E75C-4EFA-B0F4-692C5932B372"), ProgId("AdxHT_006_VC.AddinModule")]
    __gc public class AddinModule : public AddinExpress::MSO::ADXAddinModule
    {
    public:
        AddinModule(void): AddinExpress::MSO::ADXAddinModule()
        {
            InitializeComponent();
        }
        AddinModule(System::ComponentModel::IContainer *container) : components(0)
        {
            /// <summary>
            /// Required for Windows.Forms Class Composition Designer support
            /// </summary>
 
            container->Add(this);
            InitializeComponent();
        }
 
        System::ComponentModel::IContainer* GetContainer()
        {
            return components;
        }
 
        void UninstallControls()
        {
            AddinExpress::MSO::ADXAddinModule::UninstallControls();
        }
 
        [ComRegisterFunctionAttribute]
        static void AddinRegister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        static void AddinUnregister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXUnregister(t);
        }
 
    protected:
        void Dispose(Boolean disposing)
        {
            if (disposing && components)
            {
                components->Dispose();
            }
            __super::Dispose(disposing);
        }
	private: AddinExpress::MSO::ADXOutlookAppEvents *  adxOutlookEvents;
	private: System::ComponentModel::IContainer *  components;

    private:
        /// <summary>
        /// Required designer variable.
        /// </summary>

 
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        void InitializeComponent(void)
        {
			this->components = new System::ComponentModel::Container();
			this->adxOutlookEvents = new AddinExpress::MSO::ADXOutlookAppEvents(this->components);
			// 
			// adxOutlookEvents
			// 
			this->adxOutlookEvents->CommandBarsUpdate += new System::EventHandler(this, adxOutlookEvents_CommandBarsUpdate);
			// 
			// AddinModule
			// 
			this->AddinName = S"OlExample6 (VC)";
			this->Description = S"ADX2 Outlook Context Menu (VC)";
			this->SupportedApps = AddinExpress::MSO::ADXOfficeHostApp::ohaOutlook;

		}

	private:
		AddinExpress::MSO::ADXCommandBar* adxCommandBar;

	public:
        void DoCommandBarsUpdate(void);
		Outlook::_Application* OutlookHost(void);
		void DoClick(System::Object* sender);

	private: System::Void adxOutlookEvents_CommandBarsUpdate(System::Object *  sender, System::EventArgs *  e)
			 {
				 DoCommandBarsUpdate();
			 }

	};
}

